Subject: bug#61960: 30.0.50; Unexec build reliably crashes during loadup

From: Konstantin Kharlamov <[email-masked]>
Date: Sun, 05 Mar 2023 01:08:31 +0300

On Sun, 2023-03-05 at 01:00 +0300, Konstantin Kharlamov wrote:
> On Sun, 2023-03-05 at 00:56 +0300, Konstantin Kharlamov wrote:
> > On Sat, 2023-03-04 at 21:45 +0000, Andrea Corallo wrote:
> > > Konstantin Kharlamov <[email-masked]> writes:
> > > 
> > > > Oh, I am sorry, I posted the configuration line from the wrong emacs
> > > > build.
> > > > It's
> > > > supposed to be:
> > > > 
> > > > --prefix=/usr --sysconfdir=/etc --libexecdir=/usr/lib --
> > > > localstatedir=/var
> > > > -
> > > > -
> > > > mandir=/usr/share/man --with-gameuser=:games --with-modules --without-
> > > > libotf
> > > > --
> > > > without-m17n-flt --without-gconf --with-native-compilation=yes --with-
> > > > xinput2 --
> > > > with-x-toolkit=gtk3 --without-xaw3d --with-sound=no --with-tree-sitter -
> > > > -
> > > > with-
> > > > unexec --without-gpm --without-compress-install 'CFLAGS=-O0 -g3'
> > > 
> > > Hi Konstantin,
> > > 
> > > maybe the crash you see is not related but native-compilation is not
> > > supposed to work with unexec builds.
> > > 
> > > I think we should really add a configure time error for this.  Eli could
> > > this change go to emacs-29?
> > 
> > emacs-29 haven't got the BLOCK_ALIGN change, so is unaffected.
> 
> Ah, sorry, I failed to parse your text correctly, because I'm in context of
> the
> debugging session :) Yeah, if native compilation isn't supposed to work with
> unexec(), it might be a good idea to disable that, sure.

Btw, that makes me wonder how important is that to fix the unexec build at all, given it will be off when native compilation is on. Native compilation makes code faster so supposed to be the future. So presumably people will always be running with enabled, thus the unexec() path would be unused.